@echo off

rem ============================================================================
rem = Beschr.: Konfiguriert das Autodiscover-Feature von Outlook 2007, 2010,   =
rem =          2013, 2016, 2019 und Office 365 fr Windows Vista, 7, 8 und 10  =
rem = Autor:   Black Cat Networks, Gregor Glck                                =
rem = Datum:   25. Sep. 2019                                                   =
rem = Kontakt: gregor.glueck@blackcat-networks.de                              =
rem = Version: 3.1                                                             =
rem ============================================================================

setlocal enabledelayedexpansion

rem ============================================================================
rem = Auslesen der installierten Office-Version                                =
rem ============================================================================
for /f "tokens=3 delims=." %%a in ('reg query "HKEY_CLASSES_ROOT\Outlook.Application\CurVer"') do set reg=%%a

set /a i=0
for %%b in (12 14 15 16) do (
  if %%b == %reg% goto setversion
  set /a i+=1
)

:setversion
set /a n=0
for %%c in (2007 2010 2013 2016/2019/Office365) do (
  if !n! == !i! set ver=%%c && goto endloop
  set /a n+=1
)

:endloop
echo Die installierte Office Version ist: %ver%
echo.

:setdomain
rem ============================================================================
rem = Eingabe des Domainnamens                                                 =
rem ============================================================================
echo.
echo Bitte geben Sie Ihren Domainnamen ohne "www." ein:
echo.
set /p domain=Domain: 

:copyfile
rem ============================================================================
rem = Kopieren der Autodiscover-Konfigurationsdatei                            =
rem ============================================================================
copy original_domain.de.xml domain.de.xml
ren domain.de.xml %domain%.xml
md "C:\Users\%USERNAME%\AppData\Local\Black Cat Networks\Outlook Autodiscover"
copy /y %domain%.xml "C:\Users\%USERNAME%\AppData\Local\Black Cat Networks\Outlook Autodiscover"
echo Die Autodiscover-Konfigurationsdatei wurde kopiert.
echo.

:setregistry
rem ============================================================================
rem = Erstellen der notwendigen Registry-Vermerke                              =
rem ============================================================================
echo Registry-Vermerke werden erstellt...

rem = Allgemeine Registry-Eintrge
rem ==============================
reg add "HKEY_CURRENT_USER\SOFTWARE\Microsoft\Exchange\Exchange Provider" /v "DS Server" /t REG_SZ /d "000sv001.blackcat.loc" /f

rem = Versionsspezifische Registry-Eintrge fr Outlook
rem ===================================================
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v PreferLocalXML /t REG_DWORD /d 1 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ExcludeHttpsRootDomain /t REG_DWORD /d 0 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ExcludeHttpsAutoDiscoverDomain /t REG_DWORD /d 0 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ExcludeScpLookup /t REG_DWORD /d 1 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ExcludeSrvRecord /t REG_DWORD /d 1 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ExcludeHttpRedirect /t REG_DWORD /d 0 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ExcludeLastKnownGoodURL /t REG_DWORD /d 0 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ExcludeExplicitO365Endpoint /t REG_DWORD /d 1 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v ShowCertErrors /t REG_DWORD /d 0 /f
reg add "HKEY_CURRENT_USER\Software\Microsoft\Office\%reg%.0\Outlook\AutoDiscover" /v %domain% /t REG_SZ /d "C:\Users\%USERNAME%\AppData\Local\Black Cat Networks\Outlook Autodiscover\%domain%.xml" /f
reg import "RedirectServers\RedirectServers%reg%.reg"

echo Die erforderlichen Registry-Vermerke wurden erstellt.
echo.

:end
echo Autodiscover wurde auf Ihrem Computer eingerichtet.
echo BITTE STARTEN SIE DEN COMPUTER JETZT NEU.
echo.

endlocal
pause